lparameters tcRFC822
local lcTimeZone, ;
	lnID, ;
	lnStandardOffset, ;
	lnDaylightOffset, ;
	lnTimeZoneOffset, ;
	lnI, ;
	laMonths[12], ;
	lcDate, ;
	lnDay, ;
	lcMonth, ;
	lnMonth, ;
	lnYear, ;
	lnHours, ;
	lnMinutes, ;
	lnSeconds, ;
	ltDate

* Declare the time zone information API function and get the time zone
* information.
 
#define TIME_ZONE_SIZE  172
declare integer GetTimeZoneInformation in kernel32 ;
	string @lpTimeZoneInformation
lcTimeZone = replicate(chr(0), TIME_ZONE_SIZE)
lnID       = GetTimeZoneInformation(@lcTimeZone)

* Determine the standard and daylight time offset.
 
lnStandardOffset = ctobin(substr(lcTimeZone,   1, 4), '4RS')
lnDaylightOffset = ctobin(substr(lcTimeZone, 169, 4), '4RS')

* Determine the total offset based on whether the computer is on daylight time
* or not.
 
if lnID = 2  && daylight time
	lnTimeZoneOffset = (lnStandardOffset + lnDaylightOffset) * 60
else   && standard time
	lnTimeZoneOffset = lnStandardOffset * 60
endif lnID = 2

* Create an array of months.

for lnI = 1 to 12
	laMonths[lnI] = left(cmonth(date(2006, lnI, 1)), 3)
next lnI

* Parse the RFC 822 date.

lcDate    = substr(tcRFC822, at(', ', tcRFC822) + 2)
lnDay     = val(strextract(lcDate, '', ' '))
lcMonth   = strextract(lcDate, ' ', ' ', 1)
lnMonth   = ascan(laMonths, lcMonth, -1, -1, 1, 15)
lcYear    = strextract(lcDate, ' ', ' ', 2)
lnYear    = val(lcYear)
lnHours   = val(strextract(lcDate, lcYear + ' ', ':'))
lnMinutes = val(strextract(lcDate, ':', ':'))
lnSeconds = val(strextract(lcDate, ':', ' '))
ltDate    = datetime(lnYear, lnMonth, lnDay, lnHours, lnMinutes, lnSeconds) - ;
	lnTimeZoneOffset
return ltDate
